#!/bin/bash
 
if [ $# -ne 2 ]; then
  echo "Usage: `basename $0` <binary> <core>"
  exit 1
fi
 
bin=$1
core=$2 

bininfo=`ls -l $bin`
coreinfo=`ls -l $core`
 
log="$core-details.log"
rm -f $log
 
gdb -batch \
    -ex "set logging file $log" \
    -ex "set logging on" \
    -ex "set pagination off" \
    -ex "printf \"**\n** Debugging info for $bin - $core \n** Generated `date`\n\"" \
    -ex "printf \"**\n** $bininfo \n** $coreinfo\n**\n\n\"" \
    -ex "file $bin" \
    -ex "core-file $core" \
    -ex "bt" \
    -ex "info proc" \
    -ex "printf \"\n*\n* Libraries \n*\n\n\"" \
    -ex "info sharedlib" \
    -ex "printf \"\n*\n* Memory map \n*\n\n\"" \
    -ex "info target" \
    -ex "printf \"\n*\n* Registers \n*\n\n\"" \
    -ex "info registers" \
    -ex "printf \"\n*\n* Current instructions \n*\n\n\"" \
    -ex "x/16i \$pc" \
    -ex "printf \"\n*\n* Threads \n*\n\n\"" \
    -ex "info threads" \
    -ex "printf \"\n*\n* Current thread stack \n*\n\n\"" \
    -ex "bt" \
    -ex "printf \"\n*\n* All threads \n*\n\n\"" \
    -ex "thread apply all bt" \
    -ex "printf \"\n*\n* All threads (full) \n*\n\n\"" \
    -ex "thread apply all bt full" \
    -ex "printf \"\n*\n* Done \n*\n\n\"" \
    -ex "quit" 

